////////////////////////////////////////////////////////////////////////////////////////////////////
//Epizykoide - Mit Taste 'c' a und b um 1 erhöhen. Mit Taste '+' Anzahl der Punkte um 360 vergrößern
////////////////////////////////////////////////////////////////////////////////////////////////////
PVector ort;
ArrayList<PVector> punkte;//Spurpunkte
float X,Y,x,y;//Koordinaten der Orte
float r,a,b;
float D; //Punkte-Abstand
color [] farbe;
int i,j;
int faktor;
float dt;//Schrittweite
int max;
boolean stopp;

/////////////////////////////////////////////////////////////////
void setup() {
  size(1000, 1000);
  background(255);
  colorMode(HSB,256,256,256,256);
  dt =0;
  a=2; b=2;//Kardioide
//a=3; b=3;//Nephroide
  x=0;y=0;X=0;Y=0;//Initialisierung
  r=400;
  faktor = 1;
  max = faktor*360;
  i=0;
  stopp = false; 
  farbe = new color[256];  
  for(int i=0;i<256;i++){ 
    farbe[i] = color(i,255,255,255);
  } 
  ort =new PVector(x,y);       
  punkte = new ArrayList<PVector>();  
}
/////////////////////////////////////////////////////////////////////////////////////
void draw() { 
   
    translate(width/2,height/2);//Ursprung in der Bildmitte     
    strokeWeight(1);  stroke(0);
    if(!stopp){
      if(i<max){
         background(255);
         dt = i*PI/180/faktor; //Schrittweite in Grad
         x = r*cos(dt);y= r*sin(dt);
         X = r*cos(a*dt);Y= r*sin(b*dt);
         i++;
         punkte.add(new PVector(x,y));
         punkte.add(new PVector(X,Y));
                                
         for(int i =0; i< punkte.size()-1 ;i=i+2){          
           line(punkte.get(i).x,punkte.get(i).y,punkte.get(i+1).x,punkte.get(i+1).y); 
           D = sqrt(sq(punkte.get(i).x-punkte.get(i+1).x)+sq(punkte.get(i).y-punkte.get(i+1).y));//print(D+"  ");
         }                     
      }
    }else{ 
      background(255); strokeWeight(1);
      for(int i =0; i< punkte.size()-1 ;i=i+2){   
         j=i%256;
         stroke(farbe[j]);
         line(punkte.get(i).x,punkte.get(i).y,punkte.get(i+1).x,punkte.get(i+1).y);           
      }        
    }            
}
/////////////////////////////////////////////////////////////////////////////////

void mousePressed() { //zeichnen mit Farbe
   stopp = true;   
}
/////////////////////////////////////////////////////////////////////////////
void keyPressed(){
  
  if(key=='a'){   
     a=a+1; 
     i=0;
     punkte.clear();
     stopp =false;
     println("a = "+a+" b = "+b);     
  }
  if(key=='b'){  
     b=b+1; 
     i=0;
     punkte.clear();
     stopp =false;
     println("a = "+a+" b = "+b);
  }
  if(key=='c'){      
     a=a+1;  b=b+1; 
     i=0;
     punkte.clear();
     stopp =false;
     println("a = "+a+" b = "+b);
  }
  if(key=='+'){      
     faktor = faktor+1;
     max = faktor*360;
     i=0;
     punkte.clear();
     stopp =false;
     println("Anzahl Schritte: "+max);
  }
  if(key=='5'){      
    
  }
  if(key=='r'){  

  }
}

/////////////////////////////////////////////////////////////////////////////////////
